package lc.kra.cell.gui;

import java.awt.Component;
import java.util.Map;

/**
 * CellularAutomata Suite 
 *
 * Copyright 2013 Kristian Kraljic
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at

 * http://www.apache.org/licenses/LICENSE-2.0

 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 * 
 * @author <a href=mailto:kristian@kra.lc>Kristian Kraljic</a>
 */
public interface Provider<Visualization extends Component> {
	static enum Attribute { NAME,IDEA,CODE,COPYRIGHT,DESCRIPTION,SOURCE; }
	public Map<Attribute,String> getAttributes();
	
	public Visualization getVisualization();
	public Component getControls(Visualization visualization);
	public void setUp();
	public void tearDown();
}